﻿@page "/Chat"
@using ProyectoFase2.Shared.General;
@using ProyectoFase2.Shared.Models.Manager.Interpretes;
@inject NotificationService NotificationService
@inject HttpClient Http
@inject IJSRuntime JSRuntime

<style>
    .scroll-container {
        overflow-y: auto;
        scroll-behavior: smooth; /* Esto habilita la animación de desplazamiento */
        height: 300px; /* Ajusta la altura según tu diseño */
    }

    .rz-datalist-data li {
        padding: 0;
        background-color: transparent;
        border-color: transparent
    }

    .message {
        padding: 8px 12px;
        margin: 0px;
        border-radius: 8px;
        max-width: 70%;
        word-wrap: break-word;
        position: relative;
    }

    .message-text {
        margin: 0;
        padding: 0;
    }

    .from-bot .message::after {
        content: "";
        position: absolute;
        top: 50%;
        left: -12px;
        transform: translateY(-50%);
        border-width: 10px;
        border-style: solid;
        border-color: transparent white transparent transparent;
    }

    .from-usuario .message::after {
        content: "";
        position: absolute;
        top: 50%;
        right: -12px;
        transform: translateY(-50%);
        border-width: 10px;
        border-style: solid;
        border-color: transparent transparent transparent white;
    }

    .chat-container {
        display: flex;
        flex-direction: column-reverse;
        background-color: white;
    }

    .from-bot {
        text-align: left;
    }

    .from-usuario {
        text-align: right;
    }

    .user-message {
        display: flex;
        justify-content: flex-end;
    }

    .background-secondary-dark {
        background-color: #E5E5E5;
    }
</style>

<RadzenTemplateForm Data="@vm" Submit="@(async (FormViewModel args) => {  await Submit(args); })">
    <RadzenCard Class="rz-mx-auto" Style="background-color:#CFE8E3">
        <RadzenStack Orientation="Orientation.Horizontal" JustifyContent="JustifyContent.Center" Gap="1rem" >
            <RadzenStack Gap="0" JustifyContent="JustifyContent.Center" AlignItems="AlignItems.Center" Class="col-lg-4">
                <RadzenImage Path="IABOT.png" Style="width: 50px; height: auto;margin-top:-20px" />
                <RadzenText TextStyle="TextStyle.Overline" TextAlign="TextAlign.Justify" class="rz-mx-2">Hola, mi nombre es JJ, tu asistente virtual UNITEC. Te puedo ayudar con diferentes preguntas que tengas referente a temas universitarios. Si quieres ver los temas en los que te puedo ayudar, escribe TEMAS</RadzenText>
            </RadzenStack>
            <RadzenCard class="rz-background-color-primary-light rz-shadow-0 col-lg-8">
                <RadzenStack Orientation="Orientation.Vertical" JustifyContent="JustifyContent.Center" Gap="1rem" Class="rz-p-8">
                    <RadzenStack Orientation="Orientation.Horizontal" JustifyContent="JustifyContent.Center" Gap="1rem" Class="rz-p-8">
                        <RadzenTextBox @bind-Value=@vm.Search Placeholder="Search..." class="w-100" />
                        <RadzenButton Click=@(async ()=> await SearchFunction()) Text="Search" ButtonStyle="ButtonStyle.Primary" />
                    </RadzenStack>
                    <div style="display: flex; flex-direction: column; height: 350px">
                        <div style="flex:1; overflow-y: auto">
                            <div style="flex:1; overflow-y: auto" class="scroll-container">
                                <RadzenDataList @ref="dataList" Data="@messages" TItem="ChatMessage" Style="background-color:white">
                                    <Template Context="message">
                                        <div class="@(message.From == "Bot" ? "from-bot" : "from-usuario") @(message.From == "Usuario" ? "user-message" : "")">
                                            <RadzenCard class="message background-secondary-dark">
                                                <span class="message-text">@((MarkupString)message.Text)</span>
                                            </RadzenCard>
                                        </div>
                                    </Template>
                                </RadzenDataList>
                            </div>
                        </div>
                    </div>
                </RadzenStack>
            </RadzenCard>
        </RadzenStack>
    </RadzenCard>
</RadzenTemplateForm>

@code
{
    public FormViewModel vm { get; set; } = new();
    private List<ChatMessage> messages = new List<ChatMessage>();
    RadzenDataList<ChatMessage> dataList;

    async Task Submit(FormViewModel arg)
    {
        await this.SearchFunction();
    }

    public async Task SearchFunction()
    {
        if (string.IsNullOrEmpty(vm.Search))
        {
            return;
        }
        else
        {
            var text = vm.Search;
            vm.Search = string.Empty;

            messages.Add(new ChatMessage
                {
                    From = "Usuario",
                    Text = text,
                });


            try
            {
                HttpResponseMessage response = await Http.PostAsJsonAsync("api/Interprete", new InterpreteRequest
                    {
                        Text = text,
                    });

                if (response.IsSuccessStatusCode)
                {
                    InterpreteResponse respuesta = await response.Content.ReadFromJsonAsync<InterpreteResponse>();
                    if (respuesta != null && respuesta.IsSuccessed)
                    {
                        var message = string.Empty;
                        switch (respuesta.InterpreteContentResponse.Type)
                        {
                            case InterpreteResponseType.Html:
                                {
                                    message = respuesta.InterpreteContentResponse.ResultContent.ToString();
                                    break;
                                }
                            case InterpreteResponseType.Text:
                                {
                                    message = respuesta.InterpreteContentResponse.ResultContent.ToString();
                                    break;
                                }
                            case InterpreteResponseType.FileDownload:
                                {
                                    if (respuesta.InterpreteContentResponse.ResultContent == null)
                                    {
                                        message = "No se encontró el archivo";
                                    }
                                    else
                                    {
                                        message = respuesta.InterpreteContentResponse.HeaderText;
                                        string nombreArchivoPDF = "file.pdf";
                                        string base64ArchivoPDF = respuesta.InterpreteContentResponse.ResultContent.ToString();
                                        await JSRuntime.InvokeVoidAsync("descargarArchivo", base64ArchivoPDF, nombreArchivoPDF);
                                    }
                                    break;
                                }
                            default:
                                {
                                    message = "Ocurrió un error traduciendo la respuesta";
                                    break;
                                }
                        }

                        messages.Add(new ChatMessage
                            {
                                From = "Bot",
                                Text = message,
                            });
                    }
                    else
                    {
                        messages.Add(new ChatMessage
                            {
                                From = "Bot",
                                Text = respuesta == null ? "" : string.Join(",", respuesta.Error.ToArray()),
                            });
                    }
                }
                else
                {
                    messages.Add(new ChatMessage
                        {
                            From = "Bot",
                            Text = "Ha ocurrido un error interno.",
                        });
                }

            }
            catch (Exception e)
            {
                messages.Add(new ChatMessage
                    {
                        From = "Bot",
                        Text = e.Message, //"Ha ocurrido un error interno.",
                    });
            }
            finally
            {
                StateHasChanged();

                await JSRuntime.InvokeVoidAsync("scrollToEnd");
            }
        }
    }

    public class FormViewModel
    {
        public string Search { get; set; }
    }

    private class ChatMessage
    {
        public string From { get; set; }
        public string Text { get; set; }
    }
}
